首页 > 代码库 > LeetCode 35. Search Insert Position
LeetCode 35. Search Insert Position
题目描述:Given a sorted array and a target value, return the index if the target is found. If not, return the index where it would be if it were inserted in order.
You may assume no duplicates in the array.
Here are few examples.[1,3,5,6]
, 5 → 2[1,3,5,6]
, 2 → 1[1,3,5,6]
, 7 → 4[1,3,5,6]
, 0 → 0
思路:二分查找
递归二分查找:
class Solution { public: int searchInsert(vector<int>& nums, int target) { int pos; int length =nums.size(); pos = binarySearch(nums,0,length-1,target); for(;pos<length;pos++){ if(nums[pos]>=target)break; } return pos; } int binarySearch(vector<int>& nums, int first,int last, int target) { int mid = (first+last)/2; if(nums[mid]==target||first==mid) return mid; else if(nums[mid]<target){ return binarySearch(nums,mid+1,last,target); } else{ return binarySearch(nums,first,mid-1,target); } } };
迭代:
class Solution { public: int searchInsert(vector<int>& nums, int target) { int low = 0, high = nums.size()-1; // Invariant: the desired index is between [low, high+1] while (low <= high) { int mid = low + (high-low)/2; if (nums[mid] < target) low = mid+1; else high = mid-1; } // (1) At this point, low > high. That is, low >= high+1 // (2) From the invariant, we know that the index is between [low, high+1], so low <= high+1. Follwing from (1), now we know low == high+1. // (3) Following from (2), the index is between [low, high+1] = [low, low], which means that low is the desired index // Therefore, we return low as the answer. You can also return high+1 as the result, since low == high+1 return low; } };
LeetCode 35. Search Insert Position
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。